# coding: utf-8

"""
    SnapTrade

    Connect brokerage accounts to your app for live positions and trading

    The version of the OpenAPI document: 1.0.0
    Contact: api@snaptrade.com
    Generated by: https://konfigthis.com
"""

from dataclasses import dataclass
import typing_extensions
import urllib3
import json
from urllib3._collections import HTTPHeaderDict

from snaptrade_client import api_client, exceptions
from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from snaptrade_client import schemas  # noqa: F401

from snaptrade_client.model.universal_symbol import UniversalSymbol
from snaptrade_client.model.excluded_asset import ExcludedAsset

from . import path

# Path params
PortfolioGroupIdSchema = schemas.UUIDSchema
RequestRequiredPathParams = typing_extensions.TypedDict(
    'RequestRequiredPathParams',
    {
        'portfolioGroupId': typing.Union[PortfolioGroupIdSchema, str, uuid.UUID, ],
    }
)
RequestOptionalPathParams = typing_extensions.TypedDict(
    'RequestOptionalPathParams',
    {
    },
    total=False
)


class RequestPathParams(RequestRequiredPathParams, RequestOptionalPathParams):
    pass


request_path_portfolio_group_id = api_client.PathParameter(
    name="portfolioGroupId",
    style=api_client.ParameterStyle.SIMPLE,
    schema=PortfolioGroupIdSchema,
    required=True,
)
# body param
SchemaForRequestBodyApplicationJson = UniversalSymbol


request_body_universal_symbol = api_client.RequestBody(
    content={
        'application/json': api_client.MediaType(
            schema=SchemaForRequestBodyApplicationJson),
    },
)
_auth = [
    'PartnerClientId',
    'PartnerSignature',
    'PartnerTimestamp',
]
SchemaFor200ResponseBodyApplicationJson = ExcludedAsset


@dataclass
class ApiResponseFor200(api_client.ApiResponse):
    body: typing.Union[
        SchemaFor200ResponseBodyApplicationJson,
    ]


_response_for_200 = api_client.OpenApiResponse(
    response_cls=ApiResponseFor200,
    content={
        'application/json': api_client.MediaType(
            schema=SchemaFor200ResponseBodyApplicationJson),
    },
)
_status_code_to_response = {
    '200': _response_for_200,
}
_all_accept_content_types = (
    'application/json',
)


class BaseApi(api_client.Api):

    def _add_portfolio_excluded_asset_oapg(
        self,
        skip_deserialization: bool = True,
        timeout: typing.Optional[typing.Union[int, typing.Tuple]] = None,
        accept_content_types: typing.Tuple[str] = _all_accept_content_types,
        content_type: str = 'application/json',
        body: typing.Union[SchemaForRequestBodyApplicationJson,  None, dict, list, schemas.Primitive] = None,
        path_params: typing.Union[RequestPathParams, dict] = {},
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        """
        Adds an asset to exclude to a portfolio group
        :param skip_deserialization: If true then api_response.response will be set but
            api_response.body and api_response.headers will not be deserialized into schema
            class instances
        """
        self._verify_typed_dict_inputs_oapg(RequestPathParams, path_params)
        used_path = path.value

        _path_params = {}
        for parameter in (
            request_path_portfolio_group_id,
        ):
            parameter_data = path_params.get(parameter.name, schemas.unset)
            if parameter_data is schemas.unset:
                continue
            serialized_data = parameter.serialize(parameter_data)
            _path_params.update(serialized_data)

        for k, v in _path_params.items():
            used_path = used_path.replace('{%s}' % k, v)

        _headers = HTTPHeaderDict()
        # TODO add cookie handling
        if accept_content_types:
            for accept_content_type in accept_content_types:
                _headers.add('Accept', accept_content_type)

        _fields = None
        _body = None
        if body is not schemas.unset:
            serialized_data = request_body_universal_symbol.serialize(body, content_type)
            _headers.add('Content-Type', content_type)
            if 'fields' in serialized_data:
                _fields = serialized_data['fields']
            elif 'body' in serialized_data:
                _body = serialized_data['body']
        response = self.api_client.call_api(
            resource_path=used_path,
            method='post'.upper(),
            headers=_headers,
            fields=_fields,
            serialized_body=_body,
            body=body,
            auth_settings=_auth,
            timeout=timeout,
        )

        response_for_status = _status_code_to_response.get(str(response.http_response.status))
        if response_for_status:
            api_response = response_for_status.deserialize(
                                                   response,
                                                   self.api_client.configuration,
                                                   skip_deserialization=skip_deserialization
                                               )
        else:
            # If response data is JSON then deserialize for SDK consumer convenience
            is_json = api_client.JSONDetector._content_type_is_json(response.http_response.headers.get('Content-Type', ''))
            api_response = api_client.ApiResponseWithoutDeserialization(
                body=json.loads(response.http_response.data) if is_json else response.http_response.data,
                response=response.http_response,
                round_trip_time=response.round_trip_time,
                status=response.http_response.status,
                headers=response.http_response.headers,
            )

        if not 200 <= api_response.status <= 299:
            raise exceptions.ApiException(api_response=api_response)

        return api_response


class AddPortfolioExcludedAsset(BaseApi):
    # this class is used by api classes that refer to endpoints with operationId fn names

    def add_portfolio_excluded_asset(
        self,
        body: typing.Union[SchemaForRequestBodyApplicationJson,  None, dict, list, schemas.Primitive] = None,
        portfolio_group_id: typing.Any = None,
        id: typing.Any = None,
        symbol: typing.Any = None,
        raw_symbol: typing.Any = None,
        description: typing.Any = None,
        currency: typing.Any = None,
        exchange: typing.Any = None,
        type: typing.Any = None,
        currencies: typing.Any = None,
        path_params: typing.Union[RequestPathParams, dict] = {},
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        if body is None:
            body = {}
        if isinstance(body, dict) and id is not None:
            body["id"] = id
        if isinstance(body, dict) and symbol is not None:
            body["symbol"] = symbol
        if isinstance(body, dict) and raw_symbol is not None:
            body["raw_symbol"] = raw_symbol
        if isinstance(body, dict) and description is not None:
            body["description"] = description
        if isinstance(body, dict) and currency is not None:
            body["currency"] = currency
        if isinstance(body, dict) and exchange is not None:
            body["exchange"] = exchange
        if isinstance(body, dict) and type is not None:
            body["type"] = type
        if isinstance(body, dict) and currencies is not None:
            body["currencies"] = currencies
        if portfolio_group_id is not None:
            path_params["portfolioGroupId"] = portfolio_group_id
        return self._add_portfolio_excluded_asset_oapg(
            body=body,
            path_params=path_params,
        )


class ApiForpost(BaseApi):
    # this class is used by api classes that refer to endpoints by path and http method names

    def post(
        self,
        body: typing.Union[SchemaForRequestBodyApplicationJson,  None, dict, list, schemas.Primitive] = None,
        portfolio_group_id: typing.Any = None,
        id: typing.Any = None,
        symbol: typing.Any = None,
        raw_symbol: typing.Any = None,
        description: typing.Any = None,
        currency: typing.Any = None,
        exchange: typing.Any = None,
        type: typing.Any = None,
        currencies: typing.Any = None,
        path_params: typing.Union[RequestPathParams, dict] = {},
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        if body is None:
            body = {}
        if isinstance(body, dict) and id is not None:
            body["id"] = id
        if isinstance(body, dict) and symbol is not None:
            body["symbol"] = symbol
        if isinstance(body, dict) and raw_symbol is not None:
            body["raw_symbol"] = raw_symbol
        if isinstance(body, dict) and description is not None:
            body["description"] = description
        if isinstance(body, dict) and currency is not None:
            body["currency"] = currency
        if isinstance(body, dict) and exchange is not None:
            body["exchange"] = exchange
        if isinstance(body, dict) and type is not None:
            body["type"] = type
        if isinstance(body, dict) and currencies is not None:
            body["currencies"] = currencies
        if portfolio_group_id is not None:
            path_params["portfolioGroupId"] = portfolio_group_id
        return self._add_portfolio_excluded_asset_oapg(
            body=body,
            path_params=path_params,
        )


